//------------------------------------------------------------------------------
// <autogenerated>
//     This code was generated by Measurement Studio.
//     Runtime Version: 1.1.4322.2032
//
//     Changes to this file may cause incorrect behavior and will be lost if 
//     the code is regenerated.
// </autogenerated>
//------------------------------------------------------------------------------

namespace ClassLibrary3
{
    using System;
    using System.Runtime.InteropServices;
    
    
    public class niDCPower : object
    {
        
        /// <summary>
        /// Creates a new IVI instrument driver session to the power supply specified in Resource Name and returns a session handle you use to identify the power supply in all subsequent NI-DCPower function calls. This function also sends initialization commands to set the power supply to the state necessary for the operation of NI-DCPower. 
        /// 
        /// To place the power supply in a known start-up state when creating a new session, set the Reset Device parameter to Yes. This action is equivalent to using the niDCPower_reset function.
        /// 
        /// To open a session and leave the device in its existing configuration without passing through a transitional output state, set the Reset Device parameter to False, and immediately call niDCPower_Abort. To apply a new configuration without disrupting the output channels of the device, configure the device in Delayed Configuration mode as in the previous session changing only the desired settings, and then call niDCPower_Initiate.
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// Specifies the resource name assigned by Measurement &amp; Automation Explorer (MAX), for example "PXI1Slot3" where "PXI1Slot3" is an instrument's resource name. Resource name can also be a logical IVI name.
        /// </param>
        /// <param name="ID_Query">
        /// Specifies whether the device is queried to determine if the device is a valid instrument for NI-DCPower. The default value is Yes.
        /// 
        /// 
        /// </param>
        /// <param name="Reset_Device">
        /// Specifies whether to reset the power supply during the initialization procedure. The default is Yes.
        /// 
        /// </param>
        /// <param name="Instrument_Handle">
        /// Returns a session handle that you use to identify the session in all subsequent NI-DCPower function calls.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        ///           
        /// 
        /// </returns>
        public static int init(string Resource_Name, bool ID_Query, bool Reset_Device, out System.IntPtr Instrument_Handle)
        {
            int pInvokeResult = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), out Instrument_Handle);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Closes the session specified in Instrument Handle and deallocates the resources that NI-DCPower reserved. If power output is enabled when you call this function, the output channels remain in their current state and continue providing power. Use the niDCPower_ConfigureOutputEnabled function to disable power output on a per channel basis. Use the niDCPower_reset function to disable power on all output channels.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function. 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int close(System.IntPtr Instrument_Handle)
        {
            int pInvokeResult = PInvoke.close(Instrument_Handle);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the voltage level for power generation of the specified output channel(s). The output channel must be enabled for the output voltage to change. Refer to the niDCPower_ConfigureOutputEnabled function for more information about enabling the output channel.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Channel_Name">
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). 
        /// 
        /// In Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        /// </param>
        /// <param name="Level">
        /// Specifies the voltage level for the output channel generation in volts. When the specified voltage level is reached, the power supply actively regulates the generated voltage.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// 
        /// </returns>
        public static int ConfigureVoltageLevel(System.IntPtr Instrument_Handle, string Channel_Name, System.Double Level)
        {
            int pInvokeResult = PInvoke.ConfigureVoltageLevel(Instrument_Handle, Channel_Name, Level);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the current limit and behavior of the specified output channel(s). The output channel must be enabled for the output to change. Refer to the niDCPower_ConfigureOutputEnabled function for more information about enabling output channels.
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Channel_Name">
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). 
        /// 
        /// In Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        /// </param>
        /// <param name="Behavior">
        /// Specifies how the output should behave when the current limit is reached. 
        /// 
        /// Defined Values: 
        /// 
        /// - NIDCPOWER_VAL_CURRENT_REGULATE - The power supply controls the output current so that it does not exceed the current limit. Power continues to generate, even if the current limit has been reached.
        /// 
        /// </param>
        /// <param name="Limit">
        /// Specifies the maximum current limit achievable before the specified Behavior activates. Valid values for current limit are defined by the current limit range and may be limited by the power source. 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int ConfigureCurrentLimit(System.IntPtr Instrument_Handle, string Channel_Name, int Behavior, System.Double Limit)
        {
            int pInvokeResult = PInvoke.ConfigureCurrentLimit(Instrument_Handle, Channel_Name, Behavior, Limit);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Enables or disables output generation on the specified output channel(s) of the power supply. A voltage level must be set and the output channel must be enabled to generate power. Refer to the niDCPower_ConfigureVoltageLevel function for more information about setting the voltage level on an output channel.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Channel_Name">
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). 
        /// 
        /// In Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter. 
        /// </param>
        /// <param name="Enabled">
        /// Specifies whether the output is to be enabled (True) or disabled (False). 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int ConfigureOutputEnabled(System.IntPtr Instrument_Handle, string Channel_Name, bool Enabled)
        {
            int pInvokeResult = PInvoke.ConfigureOutputEnabled(Instrument_Handle, Channel_Name, System.Convert.ToUInt16(Enabled));
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the output range of the specified output channel(s). If the value specified in Range does not match one of the range options, NI-DCPower coerces the value to the next highest valid range. Refer to the NI PXI-4110 section of the NI DC Power Supplies Help for the valid output ranges for your power supply.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Channel_Name">
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). 
        /// 
        /// In Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        /// </param>
        /// <param name="Range_Type">
        /// Specifies the type of the range: voltage or current.  
        /// 
        /// Defined Values: 
        /// 
        /// - Voltage - NI-DCPower configures the                               voltage range.  
        /// - Current - NI-DCPower configures the current range. 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Range">
        /// Specifies the requested Range. Refer to the NI PXI-4110 section the NI DC Power Supplies Help for more information about the valid values for this parameter.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int ConfigureOutputRange(System.IntPtr Instrument_Handle, string Channel_Name, int Range_Type, System.Double Range)
        {
            int pInvokeResult = PInvoke.ConfigureOutputRange(Instrument_Handle, Channel_Name, Range_Type, Range);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Commits the configured settings to hardware and places the power supply in Immediate mode. Any configuration calls made after this function are applied immediately. To commit simultaneous hardware settings on multiple output channels, call the niDCPower_Abort function, configure the power supply, and call this function. 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int Initiate(System.IntPtr Instrument_Handle)
        {
            int pInvokeResult = PInvoke.Initiate(Instrument_Handle);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Places the power supply in Delayed Configuration mode. Any configuration functions called after this function are not applied until the niDCPower_Initiate function is called. If power output is enabled when you call the niDCPower_Abort function, the output channels remain in their current state and continue providing power.
        /// 
        /// Use the niDCPower_ConfigureOutputEnabled function to disable power output on a per channel basis. Use the niDCPower_reset function to disable output on all channels. While in Delayed Configuration mode, NI-DCPower performs only generic parameter validation. Any conflicting configuration calls are not validated until the niDCPower_Initiate function is called. If the same configuration is set multiple times to different values, NI-DCPower uses the last configuration call.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int Abort(System.IntPtr Instrument_Handle)
        {
            int pInvokeResult = PInvoke.Abort(Instrument_Handle);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function sets the value of a ViInt32 attribute.
        /// 
        /// This is a low-level function that you can use to set the values of instrument-specific attributes and inherent IVI attributes.  If the attribute represents a device state, this function performs instrument I/O in the following cases:
        /// 
        /// - State caching is disabled for the entire session or for the particular attribute.
        /// 
        /// - State caching is enabled and the currently cached value is invalid or is different than the value you specify. 
        /// 
        /// This instrument driver contains high-level functions that set most of the instrument attributes.  It is best to use the high-level driver functions as much as possible.  They handle order dependencies and multithread locking for you.  In addition, they perform status checking only after setting all of the attributes.  In contrast, when you set multiple attributes using the SetAttribute functions, the functions check the instrument status after each call.
        /// 
        /// Also, when state caching is enabled, the high-level functions that configure multiple attributes perform instrument I/O only for the attributes whose value you change.  Thus, you can safely call the high-level functions without the penalty of redundant instrument I/O.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The ViSession handle that you obtain from the niDCPower_Init or niDCPower_InitWithOptions  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// </param>
        /// <param name="Channel_Name">
        /// If the attribute is channel-based, this parameter specifies the name of the channel on which to set the value of the attribute. If the attribute is not channel-based, then pass VI_NULL or an empty string.
        /// 
        /// Valid Channel Names:  0,1,2
        /// 
        /// Default Value:  ""
        /// 
        /// </param>
        /// <param name="Attribute_ID">
        /// Pass the ID of an attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - Click on the control or press &lt;ENTER&gt;, &lt;spacebar&gt;, or
        ///   &lt;ctrl-down arrow&gt;, to display a dialog box containing a
        ///   hierarchical list of the available attributes.  Attributes 
        ///   whose value cannot be set are dim.  Help text is shown for 
        ///   each attribute.  Select an attribute by double-clicking on it  
        ///   or by selecting it and then pressing &lt;ENTER&gt;.
        /// 
        ///   Read-only attributes appear dim in the list box.  If you 
        ///   select a read-only attribute, an error message appears.
        /// 
        ///   A ring control at the top of the dialog box allows you to see 
        ///   all IVI attributes or only the attributes of the ViInt32 type.   
        ///   If you choose to see all IVI attributes, the data types appear
        ///   to the right of the attribute names in the list box. 
        ///   Attributes with data types other than ViInt32 are dim.  If
        ///   you select an attribute data type that is dim, LabWindows/CVI
        ///   transfers you to the function panel for the corresponding
        ///   function that is consistent with the data type.
        /// 
        /// - If you want to enter a variable name, press &lt;CTRL-T&gt; to change
        ///   this ring control to a manual input box.
        /// 
        /// - If the attribute in this ring control has named constants as  
        ///   valid values, you can view the constants by moving to the 
        ///   Attribute Value control and pressing &lt;ENTER&gt;.
        /// 
        /// </param>
        /// <param name="Attribute_Value">
        /// Pass the value to which you want to set the attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - If the attribute currently showing in the Attribute ID ring
        ///   control has constants as valid values, you can view a list of
        ///   the constants by pressing &lt;ENTER&gt; on this control.  Select a
        ///   value by double-clicking on it or by selecting it and then
        ///   pressing &lt;ENTER&gt;.  
        /// 
        ///   Note:  Some of the values might not be valid depending on the
        ///   current settings of the instrument session.
        /// 
        /// Default Value: none
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int SetAttributeViInt32(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, int Attribute_Value)
        {
            int pInvokeResult = PInvoke.SetAttributeViInt32(Instrument_Handle, Channel_Name, Attribute_ID, Attribute_Value);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function sets the value of a ViReal64 attribute.
        /// 
        /// This is a low-level function that you can use to set the values of instrument-specific attributes and inherent IVI attributes.  If the attribute represents a device state, this function performs instrument I/O in the following cases:
        /// 
        /// - State caching is disabled for the entire session or for the particular attribute.
        /// 
        /// - State caching is enabled and the currently cached value is invalid or is different than the value you specify. 
        /// 
        /// This instrument driver contains high-level functions that set most of the instrument attributes.  It is best to use the high-level driver functions as much as possible.  They handle order dependencies and multithread locking for you.  In addition, they perform status checking only after setting all of the attributes.  In contrast, when you set multiple attributes using the SetAttribute functions, the functions check the instrument status after each call.
        /// 
        /// Also, when state caching is enabled, the high-level functions that configure multiple attributes perform instrument I/O only for the attributes whose value you change.  Thus, you can safely call the high-level functions without the penalty of redundant instrument I/O.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The ViSession handle that you obtain from the niDCPower_Init or niDCPower_InitWithOptions  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// If the attribute is channel-based, this parameter specifies the name of the channel on which to set the value of the attribute. If the attribute is not channel-based, then pass VI_NULL or an empty string.
        /// 
        /// Valid Channel Names:  0,1,2
        /// 
        /// Default Value:  ""
        /// 
        /// </param>
        /// <param name="Attribute_ID">
        /// Pass the ID of an attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - Click on the control or press &lt;ENTER&gt;, &lt;spacebar&gt;, or
        ///   &lt;ctrl-down arrow&gt;, to display a dialog box containing a
        ///   hierarchical list of the available attributes.  Attributes 
        ///   whose value cannot be set are dim.  Help text is shown for 
        ///   each attribute.  Select an attribute by double-clicking on it  
        ///   or by selecting it and then pressing &lt;ENTER&gt;.
        /// 
        ///   Read-only attributes appear dim in the list box.  If you 
        ///   select a read-only attribute, an error message appears.
        /// 
        ///   A ring control at the top of the dialog box allows you to see 
        ///   all IVI attributes or only the attributes of the ViReal64
        ///   type.  If you choose to see all IVI attributes, the data types
        ///   appear to the right of the attribute names in the list box.
        ///   Attributes with data types other than ViReal64 are dim.  If
        ///   you select an attribute data type that is dim, LabWindows/CVI
        ///   transfers you to the function panel for the corresponding
        ///   function that is consistent with the data type.
        /// 
        /// - If you want to enter a variable name, press &lt;CTRL-T&gt; to change
        ///   this ring control to a manual input box.
        /// 
        /// - If the attribute in this ring control has named constants as  
        ///   valid values, you can view the constants by moving to the 
        ///   Attribute Value control and pressing &lt;ENTER&gt;.
        /// 
        /// </param>
        /// <param name="Attribute_Value">
        /// Pass the value to which you want to set the attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - If the attribute currently showing in the Attribute ID ring
        ///   control has constants as valid values, you can view a list of
        ///   the constants by pressing &lt;ENTER&gt; on this control.  Select a
        ///   value by double-clicking on it or by selecting it and then
        ///   pressing &lt;ENTER&gt;.  
        /// 
        ///   Note:  Some of the values might not be valid depending on the
        ///   current settings of the instrument session.
        /// 
        /// Default Value: none
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int SetAttributeViReal64(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.Double Attribute_Value)
        {
            int pInvokeResult = PInvoke.SetAttributeViReal64(Instrument_Handle, Channel_Name, Attribute_ID, Attribute_Value);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function sets the value of a ViString attribute.
        /// 
        /// This is a low-level function that you can use to set the values of instrument-specific attributes and inherent IVI attributes.  If the attribute represents a device state, this function performs instrument I/O in the following cases:
        /// 
        /// - State caching is disabled for the entire session or for the particular attribute.
        /// 
        /// - State caching is enabled and the currently cached value is invalid or is different than the value you specify. 
        /// 
        /// This instrument driver contains high-level functions that set most of the instrument attributes.  It is best to use the high-level driver functions as much as possible.  They handle order dependencies and multithread locking for you.  In addition, they perform status checking only after setting all of the attributes.  In contrast, when you set multiple attributes using the SetAttribute functions, the functions check the instrument status after each call.
        /// 
        /// Also, when state caching is enabled, the high-level functions that configure multiple attributes perform instrument I/O only for the attributes whose value you change.  Thus, you can safely call the high-level functions without the penalty of redundant instrument I/O.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The ViSession handle that you obtain from the niDCPower_Init or niDCPower_InitWithOptions  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// </param>
        /// <param name="Channel_Name">
        /// If the attribute is channel-based, this parameter specifies the name of the channel on which to set the value of the attribute. If the attribute is not channel-based, then pass VI_NULL or an empty string.
        /// 
        /// Valid Channel Names:  0,1,2
        /// 
        /// Default Value:  ""
        /// 
        /// </param>
        /// <param name="Attribute_ID">
        /// Pass the ID of an attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - Click on the control or press &lt;ENTER&gt;, &lt;spacebar&gt;, or
        ///   &lt;ctrl-down arrow&gt;, to display a dialog box containing a
        ///   hierarchical list of the available attributes.  Attributes 
        ///   whose value cannot be set are dim.  Help text is shown for 
        ///   each attribute.  Select an attribute by double-clicking on it  
        ///   or by selecting it and then pressing &lt;ENTER&gt;.
        /// 
        ///   Read-only attributes appear dim in the list box.  If you 
        ///   select a read-only attribute, an error message appears.
        /// 
        ///   A ring control at the top of the dialog box allows you to see 
        ///   all IVI attributes or only the attributes of the ViString
        ///   type.  If you choose to see all IVI attributes, the data types
        ///   appear to the right of the attribute names in the list box.
        ///   Attributes with data types other than ViString are dim. If
        ///   you select an attribute data type that is dim, LabWindows/CVI
        ///   transfers you to the function panel for the corresponding
        ///   function that is consistent with the data type.
        /// 
        /// - If you want to enter a variable name, press &lt;CTRL-T&gt; to change
        ///   this ring control to a manual input box.
        /// 
        /// - If the attribute in this ring control has named constants as  
        ///   valid values, you can view the constants by moving to the 
        ///   Attribute Value control and pressing &lt;ENTER&gt;.
        /// 
        /// </param>
        /// <param name="Attribute_Value">
        /// Pass the value to which you want to set the attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - If the attribute currently showing in the Attribute ID ring
        ///   control has constants as valid values, you can view a list of
        ///   the constants by pressing &lt;ENTER&gt; on this control.  Select a
        ///   value by double-clicking on it or by selecting it and then
        ///   pressing &lt;ENTER&gt;.  
        /// 
        ///   Note:  Some of the values might not be valid depending on the
        ///   current settings of the instrument session.
        /// 
        /// Default Value: none
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int SetAttributeViString(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, string Attribute_Value)
        {
            int pInvokeResult = PInvoke.SetAttributeViString(Instrument_Handle, Channel_Name, Attribute_ID, Attribute_Value);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function sets the value of a ViBoolean attribute.
        /// 
        /// This is a low-level function that you can use to set the values of instrument-specific attributes and inherent IVI attributes.  If the attribute represents a device state, this function performs instrument I/O in the following cases:
        /// 
        /// - State caching is disabled for the entire session or for the particular attribute.
        /// 
        /// - State caching is enabled and the currently cached value is invalid or is different than the value you specify. 
        /// 
        /// This instrument driver contains high-level functions that set most of the instrument attributes.  It is best to use the high-level driver functions as much as possible.  They handle order dependencies and multithread locking for you.  In addition, they perform status checking only after setting all of the attributes.  In contrast, when you set multiple attributes using the SetAttribute functions, the functions check the instrument status after each call.
        /// 
        /// Also, when state caching is enabled, the high-level functions that configure multiple attributes perform instrument I/O only for the attributes whose value you change.  Thus, you can safely call the high-level functions without the penalty of redundant instrument I/O.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The ViSession handle that you obtain from the niDCPower_Init or niDCPower_InitWithOptions  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// </param>
        /// <param name="Channel_Name">
        /// If the attribute is channel-based, this parameter specifies the name of the channel on which to set the value of the attribute. If the attribute is not channel-based, then pass VI_NULL or an empty string.
        /// 
        /// Valid Channel Names:  0,1,2
        /// 
        /// Default Value:  ""
        /// 
        /// </param>
        /// <param name="Attribute_ID">
        /// Pass the ID of an attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - Click on the control or press &lt;ENTER&gt;, &lt;spacebar&gt;, or
        ///   &lt;ctrl-down arrow&gt;, to display a dialog box containing a
        ///   hierarchical list of the available attributes.  Attributes 
        ///   whose value cannot be set are dim.  Help text is shown for 
        ///   each attribute.  Select an attribute by double-clicking on it  
        ///   or by selecting it and then pressing &lt;ENTER&gt;.
        /// 
        ///   Read-only attributes appear dim in the list box.  If you 
        ///   select a read-only attribute, an error message appears.
        /// 
        ///   A ring control at the top of the dialog box allows you to see 
        ///   all IVI attributes or only the attributes of the ViBoolean
        ///   type.  If you choose to see all IVI attributes, the data types
        ///   appear to the right of the attribute names in the list box.
        ///   Attributes with data types other than ViBoolean are dim. If
        ///   you select an attribute data type that is dim, LabWindows/CVI
        ///   transfers you to the function panel for the corresponding
        ///   function that is consistent with the data type.
        /// 
        /// - If you want to enter a variable name, press &lt;CTRL-T&gt; to change
        ///   this ring control to a manual input box.
        /// 
        /// - If the attribute in this ring control has named constants as  
        ///   valid values, you can view the constants by moving to the 
        ///   Attribute Value control and pressing &lt;ENTER&gt;.
        /// 
        /// </param>
        /// <param name="Attribute_Value">
        /// Pass the value to which you want to set the attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - If the attribute currently showing in the Attribute ID ring
        ///   control has constants as valid values, you can view a list of
        ///   the constants by pressing &lt;ENTER&gt; on this control.  Select a
        ///   value by double-clicking on it or by selecting it and then
        ///   pressing &lt;ENTER&gt;.  
        /// 
        ///   Note:  Some of the values might not be valid depending on the
        ///   current settings of the instrument session.
        /// 
        /// Default Value: none
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int SetAttributeViBoolean(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, bool Attribute_Value)
        {
            int pInvokeResult = PInvoke.SetAttributeViBoolean(Instrument_Handle, Channel_Name, Attribute_ID, System.Convert.ToUInt16(Attribute_Value));
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function sets the value of a ViSession attribute.
        /// 
        /// This is a low-level function that you can use to set the values of instrument-specific attributes and inherent IVI attributes.  If the attribute represents a device state, this function performs instrument I/O in the following cases:
        /// 
        /// - State caching is disabled for the entire session or for the particular attribute.
        /// 
        /// - State caching is enabled and the currently cached value is invalid or is different than the value you specify. 
        /// 
        /// This instrument driver contains high-level functions that set most of the instrument attributes.  It is best to use the high-level driver functions as much as possible.  They handle order dependencies and multithread locking for you.  In addition, they perform status checking only after setting all of the attributes.  In contrast, when you set multiple attributes using the SetAttribute functions, the functions check the instrument status after each call.
        /// 
        /// Also, when state caching is enabled, the high-level functions that configure multiple attributes perform instrument I/O only for the attributes whose value you change.  Thus, you can safely call the high-level functions without the penalty of redundant instrument I/O.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The ViSession handle that you obtain from the niDCPower_Init or niDCPower_InitWithOptions  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// </param>
        /// <param name="Channel_Name">
        /// If the attribute is channel-based, this parameter specifies the name of the channel on which to set the value of the attribute. If the attribute is not channel-based, then pass VI_NULL or an empty string.
        /// 
        /// Valid Channel Names:  0,1,2
        /// 
        /// Default Value:  ""
        /// 
        /// </param>
        /// <param name="Attribute_ID">
        /// Pass the ID of an attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - Click on the control or press &lt;ENTER&gt;, &lt;spacebar&gt;, or
        ///   &lt;ctrl-down arrow&gt;, to display a dialog box containing a
        ///   hierarchical list of the available attributes.  Attributes 
        ///   whose value cannot be set are dim.  Help text is shown for 
        ///   each attribute.  Select an attribute by double-clicking on it  
        ///   or by selecting it and then pressing &lt;ENTER&gt;.
        /// 
        ///   Read-only attributes appear dim in the list box.  If you 
        ///   select a read-only attribute, an error message appears.
        /// 
        ///   A ring control at the top of the dialog box allows you to see 
        ///   all IVI attributes or only the attributes of the ViSession
        ///   type.  If you choose to see all IVI attributes, the data types
        ///   appear to the right of the attribute names in the list box.
        ///   Attributes with data types other than ViSession are dim. If
        ///   you select an attribute data type that is dim, LabWindows/CVI
        ///   transfers you to the function panel for the corresponding
        ///   function that is consistent with the data type.
        /// 
        /// - If you want to enter a variable name, press &lt;CTRL-T&gt; to change
        ///   this ring control to a manual input box.
        /// 
        /// - If the attribute in this ring control has named constants as  
        ///   valid values, you can view the constants by moving to the 
        ///   Attribute Value control and pressing &lt;ENTER&gt;.
        /// 
        /// </param>
        /// <param name="Attribute_Value">
        /// Pass the value to which you want to set the attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - If the attribute currently showing in the Attribute ID ring
        ///   control has constants as valid values, you can view a list of
        ///   the constants by pressing &lt;ENTER&gt; on this control.  Select a
        ///   value by double-clicking on it or by selecting it and then
        ///   pressing &lt;ENTER&gt;.  
        /// 
        ///   Note:  Some of the values might not be valid depending on the
        ///   current settings of the instrument session.
        /// 
        /// Default Value: none
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int SetAttributeViSession(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.IntPtr Attribute_Value)
        {
            int pInvokeResult = PInvoke.SetAttributeViSession(Instrument_Handle, Channel_Name, Attribute_ID, Attribute_Value);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function queries the value of a ViInt32 attribute.
        /// 
        /// You can use this function to get the values of instrument- specific attributes and inherent IVI attributes.  If the attribute represents a device state, this function performs instrument I/O in the following cases:
        /// 
        /// - State caching is disabled for the entire session or for the particular attribute.
        /// 
        /// - State caching is enabled and the currently cached value is invalid. 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The ViSession handle that you obtain from the niDCPower_Init or niDCPower_InitWithOptions  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// </param>
        /// <param name="Channel_Name">
        /// If the attribute is channel-based, this parameter specifies the name of the channel on which to obtain the value of the attribute. If the attribute is not channel-based, then pass VI_NULL or an empty string.
        /// 
        /// Valid Channel Names:  0,1,2
        /// 
        /// Default Value:  ""
        /// 
        /// </param>
        /// <param name="Attribute_ID">
        /// Pass the ID of an attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - Click on the control or press &lt;ENTER&gt;, &lt;spacebar&gt;, or
        ///   &lt;ctrl-down arrow&gt;, to display a dialog box containing a
        ///   hierarchical list of the available attributes.  Help text is
        ///   shown for each attribute.  Select an attribute by 
        ///   double-clicking on it or by selecting it and then pressing
        ///   &lt;ENTER&gt;.
        /// 
        ///   A ring control at the top of the dialog box allows you to see 
        ///   all IVI attributes or only the attributes of the ViInt32 type. 
        ///   If you choose to see all IVI attributes, the data types appear
        ///   to the right of the attribute names in the list box.  
        ///   Attributes with data types other than ViInt32 are dim. If
        ///   you select an attribute data type that is dim, LabWindows/CVI
        ///   transfers you to the function panel for the corresponding
        ///   function that is consistent with the data type.
        /// 
        /// - If you want to enter a variable name, press &lt;CTRL-T&gt; to change
        ///   this ring control to a manual input box.
        /// 
        /// - If the attribute in this ring control has named constants as  
        ///   valid values, you can view the constants by moving to the 
        ///   Attribute Value control and pressing &lt;ENTER&gt;.
        /// 
        /// </param>
        /// <param name="Attribute_Value">
        /// Returns the current value of the attribute.  Pass the address of a ViInt32 variable.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - If the attribute currently showing in the Attribute ID ring
        ///   control has named constants as valid values, you can view a
        ///   list of the constants by pressing &lt;ENTER&gt; on this control.  
        ///   Select a value by double-clicking on it or by selecting it and 
        ///   then pressing &lt;ENTER&gt;.  
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int GetAttributeViInt32(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out int Attribute_Value)
        {
            int pInvokeResult = PInvoke.GetAttributeViInt32(Instrument_Handle, Channel_Name, Attribute_ID, out Attribute_Value);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function queries the value of a ViReal64 attribute.
        /// 
        /// You can use this function to get the values of instrument- specific attributes and inherent IVI attributes.  If the attribute represents a device state, this function performs instrument I/O in the following cases:
        /// 
        /// - State caching is disabled for the entire session or for the particular attribute.
        /// 
        /// - State caching is enabled and the currently cached value is invalid. 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The ViSession handle that you obtain from the niDCPower_Init or niDCPower_InitWithOptions  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// </param>
        /// <param name="Channel_Name">
        /// If the attribute is channel-based, this parameter specifies the name of the channel on which to obtain the value of the attribute. If the attribute is not channel-based, then pass VI_NULL or an empty string.
        /// 
        /// Valid Channel Names:  0,1,2
        /// 
        /// Default Value:  ""
        /// 
        /// </param>
        /// <param name="Attribute_ID">
        /// Pass the ID of an attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - Click on the control or press &lt;ENTER&gt;, &lt;spacebar&gt;, or
        ///   &lt;ctrl-down arrow&gt;, to display a dialog box containing a
        ///   hierarchical list of the available attributes.  Help text is
        ///   shown for each attribute.  Select an attribute by 
        ///   double-clicking on it or by selecting it and then pressing
        ///   &lt;ENTER&gt;.
        /// 
        ///   A ring control at the top of the dialog box allows you to see 
        ///   all IVI attributes or only the attributes of the ViReal64
        ///   type.  If you choose to see all IVI attributes, the data types
        ///   appear to the right of the attribute names in the list box. 
        ///   Attributes with data types other than ViReal64 are dim. If
        ///   you select an attribute data type that is dim, LabWindows/CVI
        ///   transfers you to the function panel for the corresponding
        ///   function that is consistent with the data type.
        /// 
        /// - If you want to enter a variable name, press &lt;CTRL-T&gt; to change
        ///   this ring control to a manual input box.
        /// 
        /// - If the attribute in this ring control has named constants as  
        ///   valid values, you can view the constants by moving to the 
        ///   Attribute Value control and pressing &lt;ENTER&gt;.
        /// 
        /// </param>
        /// <param name="Attribute_Value">
        /// Returns the current value of the attribute.  Pass the address of a ViReal64 variable.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - If the attribute currently showing in the Attribute ID ring
        ///   control has named constants as valid values, you can view a
        ///   list of the constants by pressing &lt;ENTER&gt; on this control.  
        ///   Select a value by double-clicking on it or by selecting it and 
        ///   then pressing &lt;ENTER&gt;.  
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int GetAttributeViReal64(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.Double Attribute_Value)
        {
            int pInvokeResult = PInvoke.GetAttributeViReal64(Instrument_Handle, Channel_Name, Attribute_ID, out Attribute_Value);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function queries the value of a ViString attribute.
        /// 
        /// You can use this function to get the values of instrument- specific attributes and inherent IVI attributes.  If the attribute represents a device state, this function performs instrument I/O in the following cases:
        /// 
        /// - State caching is disabled for the entire session or for the particular attribute.
        /// 
        /// - State caching is enabled and the currently cached value is invalid. 
        /// 
        /// You must provide a ViChar array to serve as a buffer for the value.  You pass the number of bytes in the buffer as the Buffer Size parameter.  If the current value of the attribute, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// If you want to call this function just to get the required buffer size, you can pass 0 for the Buffer Size and VI_NULL for the Attribute Value buffer.  
        /// 
        /// If you want the function to fill in the buffer regardless of the   number of bytes in the value, pass a negative number for the Buffer Size parameter.  
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The ViSession handle that you obtain from the niDCPower_Init or niDCPower_InitWithOptions  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// </param>
        /// <param name="Channel_Name">
        /// If the attribute is channel-based, this parameter specifies the name of the channel on which to obtain the value of the attribute. If the attribute is not channel-based, then pass VI_NULL or an empty string.
        /// 
        /// Valid Channel Names:  0,1,2
        /// 
        /// Default Value:  ""
        /// 
        /// </param>
        /// <param name="Attribute_ID">
        /// Pass the ID of an attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - Click on the control or press &lt;ENTER&gt;, &lt;spacebar&gt;, or
        ///   &lt;ctrl-down arrow&gt;, to display a dialog box containing a
        ///   hierarchical list of the available attributes.  Help text is
        ///   shown for each attribute.  Select an attribute by 
        ///   double-clicking on it or by selecting it and then pressing
        ///   &lt;ENTER&gt;.
        /// 
        ///   A ring control at the top of the dialog box allows you to see 
        ///   all IVI attributes or only the attributes of the ViString
        ///   type.  If you choose to see all IVI attributes, the data types
        ///   appear to the right of the attribute names in the list box. 
        ///   Attributes with data types other than ViString are dim. If
        ///   you select an attribute data type that is dim, LabWindows/CVI
        ///   transfers you to the function panel for the corresponding
        ///   function that is consistent with the data type.
        /// 
        /// - If you want to enter a variable name, press &lt;CTRL-T&gt; to change
        ///   this ring control to a manual input box.
        /// 
        /// - If the attribute in this ring control has named constants as  
        ///   valid values, you can view the constants by moving to the 
        ///   Attribute Value control and pressing &lt;ENTER&gt;.
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// Pass the number of bytes in the ViChar array you specify for the Attribute Value parameter.  
        /// 
        /// If the current value of the attribute, including the terminating NUL byte, contains more bytes that you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// If you pass 0, you can pass VI_NULL for the Attribute Value buffer parameter.
        /// 
        /// </param>
        /// <param name="Attribute_Value">
        /// The buffer in which the function returns the current value of the attribute.  The buffer must be of type ViChar and have at least as many bytes as indicated in the Buffer Size parameter.
        /// 
        /// If the current value of the attribute, including the terminating NUL byte, contains more bytes that you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// If you specify 0 for the Buffer Size parameter, you can pass VI_NULL for this parameter.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - If the attribute currently showing in the Attribute ID ring
        ///   control has named constants as valid values, you can view a
        ///   list of the constants by pressing &lt;ENTER&gt; on this control.  
        ///   Select a value by double-clicking on it or by selecting it and 
        ///   then pressing &lt;ENTER&gt;.  
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int GetAttributeViString(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, int Buffer_Size, System.Text.StringBuilder Attribute_Value)
        {
            int pInvokeResult = PInvoke.GetAttributeViString(Instrument_Handle, Channel_Name, Attribute_ID, Buffer_Size, Attribute_Value);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function queries the value of a ViBoolean attribute.
        /// 
        /// You can use this function to get the values of instrument- specific attributes and inherent IVI attributes.  If the attribute represents a device state, this function performs instrument I/O in the following cases:
        /// 
        /// - State caching is disabled for the entire session or for the particular attribute.
        /// 
        /// - State caching is enabled and the currently cached value is invalid. 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The ViSession handle that you obtain from the niDCPower_Init or niDCPower_InitWithOptions  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// </param>
        /// <param name="Channel_Name">
        /// If the attribute is channel-based, this parameter specifies the name of the channel on which to obtain the value of the attribute. If the attribute is not channel-based, then pass VI_NULL or an empty string.
        /// 
        /// Valid Channel Names:  0,1,2
        /// 
        /// Default Value:  ""
        /// 
        /// </param>
        /// <param name="Attribute_ID">
        /// Pass the ID of an attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - Click on the control or press &lt;ENTER&gt;, &lt;spacebar&gt;, or
        ///   &lt;ctrl-down arrow&gt;, to display a dialog box containing a
        ///   hierarchical list of the available attributes.  Help text is
        ///   shown for each attribute.  Select an attribute by 
        ///   double-clicking on it or by selecting it and then pressing
        ///   &lt;ENTER&gt;.
        /// 
        ///   A ring control at the top of the dialog box allows you to see 
        ///   all IVI attributes or only the attributes of the ViBoolean
        ///   type.  If you choose to see all IVI attributes, the data types
        ///   appear to the right of the attribute names in the list box. 
        ///   Attributes with data types other than ViBoolean are dim. If
        ///   you select an attribute data type that is dim, LabWindows/CVI
        ///   transfers you to the function panel for the corresponding
        ///   function that is consistent with the data type.
        /// 
        /// - If you want to enter a variable name, press &lt;CTRL-T&gt; to change
        ///   this ring control to a manual input box.
        /// 
        /// - If the attribute in this ring control has named constants as  
        ///   valid values, you can view the constants by moving to the 
        ///   Attribute Value control and pressing &lt;ENTER&gt;.
        /// 
        /// </param>
        /// <param name="Attribute_Value">
        /// Returns the current value of the attribute.  Pass the address of a ViBoolean variable.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - If the attribute currently showing in the Attribute ID ring
        ///   control has named constants as valid values, you can view a
        ///   list of the constants by pressing &lt;ENTER&gt; on this control.  
        ///   Select a value by double-clicking on it or by selecting it and 
        ///   then pressing &lt;ENTER&gt;.  
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int GetAttributeViBoolean(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out bool Attribute_Value)
        {
            System.UInt16 Attribute_ValueAsUShort;
            int pInvokeResult = PInvoke.GetAttributeViBoolean(Instrument_Handle, Channel_Name, Attribute_ID, out Attribute_ValueAsUShort);
            Attribute_Value = System.Convert.ToBoolean(Attribute_ValueAsUShort);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function queries the value of a ViSession attribute.
        /// 
        /// You can use this function to get the values of instrument- specific attributes and inherent IVI attributes.  If the attribute represents a device state, this function performs instrument I/O in the following cases:
        /// 
        /// - State caching is disabled for the entire session or for the particular attribute.
        /// 
        /// - State caching is enabled and the currently cached value is invalid. 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The ViSession handle that you obtain from the niDCPower_Init or niDCPower_InitWithOptions  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// </param>
        /// <param name="Channel_Name">
        /// If the attribute is channel-based, this parameter specifies the name of the channel on which to obtain the value of the attribute. If the attribute is not channel-based, then pass VI_NULL or an empty string.
        /// 
        /// Valid Channel Names:  0,1,2
        /// 
        /// Default Value:  ""
        /// 
        /// </param>
        /// <param name="Attribute_ID">
        /// Pass the ID of an attribute.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - Click on the control or press &lt;ENTER&gt;, &lt;spacebar&gt;, or
        ///   &lt;ctrl-down arrow&gt;, to display a dialog box containing a
        ///   hierarchical list of the available attributes.  Help text is
        ///   shown for each attribute.  Select an attribute by 
        ///   double-clicking on it or by selecting it and then pressing
        ///   &lt;ENTER&gt;.
        /// 
        ///   A ring control at the top of the dialog box allows you to see 
        ///   all IVI attributes or only the attributes of the ViSession
        ///   type.  If you choose to see all IVI attributes, the data types
        ///   appear to the right of the attribute names in the list box. 
        ///   Attributes with data types other than ViSession are dim. If
        ///   you select an attribute data type that is dim, LabWindows/CVI
        ///   transfers you to the function panel for the corresponding
        ///   function that is consistent with the data type.
        /// 
        /// - If you want to enter a variable name, press &lt;CTRL-T&gt; to change
        ///   this ring control to a manual input box.
        /// 
        /// - If the attribute in this ring control has named constants as  
        ///   valid values, you can view the constants by moving to the 
        ///   Attribute Value control and pressing &lt;ENTER&gt;.
        /// 
        /// </param>
        /// <param name="Attribute_Value">
        /// Returns the current value of the attribute.  Pass the address of a ViSession variable.
        /// 
        /// From the function panel window, you can use this control as follows.
        /// 
        /// - If the attribute currently showing in the Attribute ID ring
        ///   control has named constants as valid values, you can view a
        ///   list of the constants by pressing &lt;ENTER&gt; on this control.  
        ///   Select a value by double-clicking on it or by selecting it and 
        ///   then pressing &lt;ENTER&gt;.  
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int GetAttributeViSession(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.IntPtr Attribute_Value)
        {
            int pInvokeResult = PInvoke.GetAttributeViSession(Instrument_Handle, Channel_Name, Attribute_ID, out Attribute_Value);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Queries the specified output channel to determine if the output channel is currently in the state specified by Output State.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Channel_Name">
        /// Specifies the output channel to query.
        /// </param>
        /// <param name="Output_State">
        /// Specifies the Output State of the output channel that is being queried. 
        /// 
        /// Defined Values:
        /// 
        /// - Constant Voltage - The power supply is maintaining a constant voltage by adjusting the current.
        /// - Constant Current - The power supply is maintaining a constant current by adjusting the voltage.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="In_State">
        /// Returns whether the power supply output channel is in the specified state.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int QueryOutputState(System.IntPtr Instrument_Handle, string Channel_Name, int Output_State, out bool In_State)
        {
            System.UInt16 In_StateAsUShort;
            int pInvokeResult = PInvoke.QueryOutputState(Instrument_Handle, Channel_Name, Output_State, out In_StateAsUShort);
            In_State = System.Convert.ToBoolean(In_StateAsUShort);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the measured value of either the voltage or current on the specified output channel. Each call to this function blocks other function calls until the hardware returns the Measurement. The Measurement speed of the power supply and the NIDCPOWER_ATTR_SAMPLES_TO_AVERAGE attribute dictate the length of time that a Measurement takes. To measure multiple output channels, use the niDCPower_MeasureMultiple function. 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Channel_Name">
        /// Specifies the output channel to measure.
        /// </param>
        /// <param name="Measurement_Type">
        /// Specifies whether a voltage or current value should be measured.
        /// 
        /// Defined Values: 
        /// 
        /// - Voltage - The power supply measures voltage.  
        /// - Current - The power supply measures current.
        /// </param>
        /// <param name="Measurement">
        /// Returns the value of the measurement, either in volts for voltage or amps for current.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int Measure(System.IntPtr Instrument_Handle, string Channel_Name, int Measurement_Type, out System.Double Measurement)
        {
            int pInvokeResult = PInvoke.Measure(Instrument_Handle, Channel_Name, Measurement_Type, out Measurement);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns arrays of the measured voltage and current values on the specified output channel(s). Each call to this function blocks other function calls until the measurements are returned from the power supply. The order of the measurements returned in the array corresponds to the order of the specified output channels. The measurement speed of the power supply and the NIDCPOWER_ATTR_SAMPLES_TO_AVERAGE attribute dictates the length of time that a measurement takes. 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Channel_Name">
        /// Specifies the output channels to measure. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2).
        /// </param>
        /// <param name="Voltage_Measurements">
        /// Returns an array of voltage measurements. The measurements in the array are returned in the same order as the channels specified in Channel Name. Ensure that sufficient space has been allocated for the returned array.
        /// </param>
        /// <param name="Current_Measurements">
        /// Returns an array of current measurements. The measurements in the array are returned in the same order as the channels specified in Channel Name. Ensure that sufficient space has been allocated for the returned array.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int MeasureMultiple(System.IntPtr Instrument_Handle, string Channel_Name, System.Double[] Voltage_Measurements, System.Double[] Current_Measurements)
        {
            int pInvokeResult = PInvoke.MeasureMultiple(Instrument_Handle, Channel_Name, Voltage_Measurements, Current_Measurements);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Queries the maximum current limit on an output channel if the output channel is set to the specified Voltage Level.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Channel_Name">
        /// Specifies the output channel to query.
        /// </param>
        /// <param name="Voltage_Level">
        /// Specifies the voltage level to use when calculating the Max Current Limit.
        /// </param>
        /// <param name="Max_Current_Limit">
        /// Returns the maximum current limit that can be set with the specified Voltage Level.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int QueryMaxCurrentLimit(System.IntPtr Instrument_Handle, string Channel_Name, System.Double Voltage_Level, out System.Double Max_Current_Limit)
        {
            int pInvokeResult = PInvoke.QueryMaxCurrentLimit(Instrument_Handle, Channel_Name, Voltage_Level, out Max_Current_Limit);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Queries the maximum voltage level on an output channel if the output channel is set to the specified Current Limit.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Channel_Name">
        /// Specifies the output channel to query.
        /// </param>
        /// <param name="Current_Limit">
        /// Specifies the current limit to use when calculating the Max Voltage Level.
        /// </param>
        /// <param name="Max_Voltage_Level">
        /// Returns the maximum voltage level that can be set on an output channel with the specified Current Limit.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int QueryMaxVoltageLevel(System.IntPtr Instrument_Handle, string Channel_Name, System.Double Current_Limit, out System.Double Max_Voltage_Level)
        {
            int pInvokeResult = PInvoke.QueryMaxVoltageLevel(Instrument_Handle, Channel_Name, Current_Limit, out Max_Voltage_Level);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Queries the minimum current limit on an output channel if the output channel is set to the specified Voltage Level.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Channel_Name">
        /// Specifies the output channel to query.
        /// </param>
        /// <param name="Voltage_Level">
        /// Specifies the voltage level to use when calculating the min Current Limit.
        /// </param>
        /// <param name="Min_Current_Limit">
        /// Returns the minimum current limit that can be set on an output channel with the specified Voltage Level.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int QueryMinCurrentLimit(System.IntPtr Instrument_Handle, string Channel_Name, System.Double Voltage_Level, out System.Double Min_Current_Limit)
        {
            int pInvokeResult = PInvoke.QueryMinCurrentLimit(Instrument_Handle, Channel_Name, Voltage_Level, out Min_Current_Limit);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// If Password is valid, this function creates a new IVI instrument driver session to the power supply specified in Resource Name and returns an instrument handle you use to identify the power supply in all subsequent NI-DCPower function calls. This function also sends initialization commands to set the power supply to the state necessary for the operation of NI-DCPower.
        /// 
        /// Opening a calibration session always performs a reset. Refer to the calibration procedure for the power supply you are calibrating for detailed instructions on the appropriate use of this function.
        /// 
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// Specifies the resource name assigned by Measurement &amp; Automation Explorer (MAX), for example "PXI1Slot3" where "PXI1Slot3" is an instrument's resource name. Resource Name can also be a logical IVI name. 
        /// </param>
        /// <param name="Password">
        /// Specifies the Password for opening a calibration session. Password can be a maximum of four alphanumeric characters.
        /// </param>
        /// <param name="Instrument_Handle">
        /// Returns a handle that you use to identify the session in all subsequent NI-DCPower function calls.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int InitExtCal(string Resource_Name, string Password, out System.IntPtr Instrument_Handle)
        {
            int pInvokeResult = PInvoke.InitExtCal(Resource_Name, Password, out Instrument_Handle);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Closes the session specified in Instrument Handle and deallocates the resources that NI-DCPower reserved for calibration. Refer to the calibration procedure for the power supply you are calibrating for detailed instructions on the appropriate use of this function. If an error occurs before this function, Action defaults to Cancel.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
        /// </param>
        /// <param name="Action">
        /// Specifies how to use the calibration values from this session as the session is closed. 
        /// 
        /// Defined Values: 
        /// 
        /// - Commit - The new calibration constants are stored in the EEPROM. 
        /// - Cancel - The old calibration constants are kept, and the new ones are discarded. 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int CloseExtCal(System.IntPtr Instrument_Handle, int Action)
        {
            int pInvokeResult = PInvoke.CloseExtCal(Instrument_Handle, Action);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Calculates the calibration constants for the voltage level for the specified output channel. This function compares the array in Requested Outputs to the array in Measured Outputs and calculates the calibration constants for the voltage level of the output channel. 
        /// 
        /// Refer to the calibration procedure of the power supply you are calibrating for detailed instructions on the appropriate use of this function. This function can only be called in an external calibration session.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
        /// </param>
        /// <param name="Channel_Name">
        /// Specifies the output channel to which these calibration settings apply.
        /// </param>
        /// <param name="Range">
        /// Specifies the input range used for these calibration settings.
        /// </param>
        /// <param name="Number_Of_Measurements">
        /// Specifies the number of elements in Requested Outputs and Measured Outputs.
        /// </param>
        /// <param name="Requested_Outputs">
        /// Specifies an array of the output values requested in the niDCPower_ConfigureVoltageLevel function.
        /// </param>
        /// <param name="Measured_Outputs">
        /// Specifies an array of the output values measured by an external precision digital multimeter.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int CalAdjustVoltageLevel(System.IntPtr Instrument_Handle, string Channel_Name, System.Double Range, System.UInt32 Number_Of_Measurements, System.Double Requested_Outputs, System.Double Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustVoltageLevel(Instrument_Handle, Channel_Name, Range, Number_Of_Measurements, Requested_Outputs, Measured_Outputs);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Calculates the calibration constants for the voltage measurements returned by the niDCPower_Measure function for the specified output channel. This function compares the array in Reported Outputs to the array in Measured Outputs and calculates the calibration constants for the voltage measurements returned by the niDCPower_Measure function. 
        /// 
        /// Refer to the calibration procedure for the power supply you are calibrating for detailed instructions on the appropriate use of this function. This function can only be called in an external calibration session.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
        /// </param>
        /// <param name="Channel_Name">
        /// Specifies the channel name to which these calibration settings apply.
        /// </param>
        /// <param name="Range">
        /// Specifies the input range used for these calibration settings. 
        /// </param>
        /// <param name="Number_Of_Measurements">
        /// Specifies the number of elements in Requested Outputs and Measured Outputs. 
        /// </param>
        /// <param name="Reported_Outputs">
        /// Specifies an array of the output values that were returned by the niDCPower_Measure function.
        /// </param>
        /// <param name="Measured_Outputs">
        /// Specifies an array of the output values measured by an external precision digital multimeter.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int CalAdjustVoltageMeasurement(System.IntPtr Instrument_Handle, string Channel_Name, System.Double Range, System.UInt32 Number_Of_Measurements, System.Double Reported_Outputs, System.Double Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustVoltageMeasurement(Instrument_Handle, Channel_Name, Range, Number_Of_Measurements, Reported_Outputs, Measured_Outputs);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Calculates the calibration constants for the current limit for the specified output channel and range. This function compares the array in Requested Outputs to the array in Measured Outputs and calculates the calibration constants for the current limit returned by the power supply. 
        /// 
        /// Refer to the calibration procedure for the power supply you are calibrating for detailed instructions on the appropriate use of this function. This function can only be called from an external calibration session. 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
        /// </param>
        /// <param name="Channel_Name">
        /// Specifies the channel name to which these calibration settings apply.
        /// </param>
        /// <param name="Range">
        /// Specifies the input range used for these calibration settings. 
        /// </param>
        /// <param name="Number_Of_Measurements">
        /// Specifies the number of elements in Requested Outputs and Measured Outputs. 
        /// </param>
        /// <param name="Requested_Outputs">
        /// Specifies an array of the output values that were requested in the niDCPower_ConfigureCurrentLimit function.
        /// </param>
        /// <param name="Measured_Outputs">
        /// Specifies an array of the output values measured by an external precision digital multimeter.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int CalAdjustCurrentLimit(System.IntPtr Instrument_Handle, string Channel_Name, System.Double Range, System.UInt32 Number_Of_Measurements, System.Double Requested_Outputs, System.Double Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustCurrentLimit(Instrument_Handle, Channel_Name, Range, Number_Of_Measurements, Requested_Outputs, Measured_Outputs);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Calibrates the current measurements returned by the niDCPower_Measure function for the specified output channel. This function calculates the calibration constants for the array in Reported Outputs to the array in Measured Outputs and calculates the calibration constants for the current measurements returned by the niDCPower_Measure function. 
        /// 
        /// Refer to the calibration procedure for the power supply you are calibrating for detailed instructions on the appropriate use of this function. This function can only be called in an external calibration session. 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
        /// </param>
        /// <param name="Channel_Name">
        /// Specifies the channel name to which these calibration settings apply.
        /// </param>
        /// <param name="Range">
        /// Specifies the input range used for these calibration settings.
        /// </param>
        /// <param name="Number_Of_Measurements">
        /// Specifies the number of elements in Reported Outputs and Measured Outputs.
        /// </param>
        /// <param name="Reported_Outputs">
        /// Specifies an array of the output values that were returned by the niDCPower_Measure function.
        /// </param>
        /// <param name="Measured_Outputs">
        /// Specifies an array of the output values measured by an external precision digital multimeter.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int CalAdjustCurrentMeasurement(System.IntPtr Instrument_Handle, string Channel_Name, System.Double Range, System.UInt32 Number_Of_Measurements, System.Double Reported_Outputs, System.Double Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustCurrentMeasurement(Instrument_Handle, Channel_Name, Range, Number_Of_Measurements, Reported_Outputs, Measured_Outputs);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Changes the Password that is required to initialize an external calibration session. The Password can be a maximum of four alphanumeric characters. If you call this function in a regular session, Password is changed immediately. If you call this function in an external calibration session, Password is changed only after you close the session using the niDCPower_CloseExtCal function with Action set to Commit.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
        /// </param>
        /// <param name="Old_Password">
        /// Specifies the previous password used to protect the calibration values.
        /// </param>
        /// <param name="New_Password">
        /// Specifies the new password to use to protect the calibration values.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int ChangeExtCalPassword(System.IntPtr Instrument_Handle, string Old_Password, string New_Password)
        {
            int pInvokeResult = PInvoke.ChangeExtCalPassword(Instrument_Handle, Old_Password, New_Password);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the recommended maximum interval, in Months, between external calibrations.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
        /// </param>
        /// <param name="Months">
        /// Specifies the recommended maximum interval, in Months, between external calibrations in months.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int GetExtCalRecommendedInterval(System.IntPtr Instrument_Handle, int Months)
        {
            int pInvokeResult = PInvoke.GetExtCalRecommendedInterval(Instrument_Handle, Months);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the date and time of the last successful calibration. The time returned is 24-hour (military) local time; for example, if the power supply was calibrated at 2:30 PM, this function returns 14 for Hours and 30 for Minutes.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
        /// </param>
        /// <param name="Year">
        /// Returns the Year in which the power supply was last calibrated. 
        /// </param>
        /// <param name="Month">
        /// Returns the Month in which the power supply was last calibrated.
        /// </param>
        /// <param name="Day">
        /// Returns returns the Day on which the power supply was last calibrated. 
        /// </param>
        /// <param name="Hour">
        /// Returns the Hour (in 24-hour time) in which the power supply was last calibrated.
        /// </param>
        /// <param name="Minute">
        /// Returns the Minute in which the power supply was last calibrated.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int GetExtCalLastDateAndTime(System.IntPtr Instrument_Handle, int Year, int Month, int Day, int Hour, int Minute)
        {
            int pInvokeResult = PInvoke.GetExtCalLastDateAndTime(Instrument_Handle, Year, Month, Day, Hour, Minute);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the maximum number of characters that can be used to store user-defined information in the power supply onboard EEPROM.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Info_Size">
        /// Returns the number of characters that can be stored in the power supply onboard EEPROM.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int GetCalUserDefinedInfoMaxSize(System.IntPtr Instrument_Handle, int Info_Size)
        {
            int pInvokeResult = PInvoke.GetCalUserDefinedInfoMaxSize(Instrument_Handle, Info_Size);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Stores a user-defined string of characters in the power supply onboard EEPROM. If the string is longer than the maximum allowable size, it is truncated. This function overwrites any existing user-defined information.
        /// 
        /// If you call this function in a regular session, Info is immediately changed. If you call this function in an external calibration session, Info is changed only after you close the session using the niDCPower_CloseExtCal function with Action set to Commit.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Info">
        /// Specifies the string to store in the power supply onboard EEPROM.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int SetCalUserDefinedInfo(System.IntPtr Instrument_Handle, string Info)
        {
            int pInvokeResult = PInvoke.SetCalUserDefinedInfo(Instrument_Handle, Info);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the user-defined information in the power supply onboard EEPROM.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
        /// </param>
        /// <param name="Info">
        /// Returns the user-defined information stored in the power supply onboard EEPROM.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int GetCalUserDefinedInfo(System.IntPtr Instrument_Handle, string Info)
        {
            int pInvokeResult = PInvoke.GetCalUserDefinedInfo(Instrument_Handle, Info);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the current onboard Temperature, in degrees Celsius, of the power supply.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Temperature">
        /// Returns the onboard Temperature, in degrees Celsius, of the power supply.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int ReadCurrentTemperature(System.IntPtr Instrument_Handle, System.Double Temperature)
        {
            int pInvokeResult = PInvoke.ReadCurrentTemperature(Instrument_Handle, Temperature);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the onboard Temperature of the power supply, in degrees Celsius, during the last successful external calibration.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
        /// </param>
        /// <param name="Temperature">
        /// Returns the onboard Temperature of the power supply, in degrees Celsius, during the last successful external calibration.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int GetExtCalLastTemp(System.IntPtr Instrument_Handle, System.Double Temperature)
        {
            int pInvokeResult = PInvoke.GetExtCalLastTemp(Instrument_Handle, Temperature);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Creates a new IVI instrument driver session to the power supply specified in Resource Name and returns a session handle you use to identify the power supply in all subsequent NI-DCPower function calls. With this function, you can optionally set the initial state of the following session attributes: 
        /// 
        /// NIDCPOWER_ATTR_SIMULATE, NIDCPOWER_ATTR_DRIVER_SETUP, NIDCPOWER_ATTR_RANGE_CHECK, NIDCPOWER_ATTR_QUERY_INSTRUMENT_STATUS, 
        /// NIDCPOWER_ATTR_CACHE, NIDCPOWER_ATTR_SIMULATE, and NIDCPOWER_ATTR_RECORD_COERCIONS.
        /// 
        /// This function also sends initialization commands to set the power supply to the state necessary for NI-DCPower to operate. 
        /// 
        /// To place the power supply in a known start-up state when creating a new session, set the Reset Device parameter to Yes. This action is equivalent to using the niDCPower_reset function.
        /// 
        /// To open a session and leave the device in its existing configuration without passing through a transitional output state, set the Reset Device parameter to False, and immediately call niDCPower_Abort. To apply a new configuration without disrupting the output channels of the device, configure the device in Delayed Configuration mode as in the previous session changing only the desired settings, and then call niDCPower_Initiate.
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// Specifies the Resource Name assigned by Measurement &amp; Automation Explorer (MAX), for example "PXI1Slot3" where "PXI1Slot3" is an instrument's Resource Name. Resource Name can also be a logical IVI name. 
        /// </param>
        /// <param name="ID_Query">
        /// Specifies whether the device is queried to determine if the device is a valid instrument for NI-DCPower. The default value is VI_TRUE.
        /// </param>
        /// <param name="Reset_Device">
        /// Specifies whether to reset the power supply during the initialization procedure. The default value is VI_TRUE. 
        /// </param>
        /// <param name="Option_String">
        /// Specifies the initial value of certain attributes for the session. The syntax for optionString is a list of attributes with an assigned value where 1 is VI_TRUE and 0 is VI_FALSE. Each attribute/value combination is delimited with a comma, as shown in the following example:
        /// 
        /// "Simulate=0,RangeCheck=1,QueryInstrStatus=0,Cache=1"
        /// 
        /// If you do not wire this input or pass an empty string, the session assigns the default values, shown in the example, for these attributes. You do not have to specify a value for all the attributes. If you do not specify a value for an attribute, the default value is used. 
        /// </param>
        /// <param name="Instrument_Handle">
        /// Returns a handle that you use to identify the power supply in all subsequent NI-DCPower function calls.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int InitWithOptions(string Resource_Name, bool ID_Query, bool Reset_Device, string Option_String, out System.IntPtr Instrument_Handle)
        {
            int pInvokeResult = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Option_String, out Instrument_Handle);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Places the power supply in a quiescent state where it has minimal or no impact on the system to which it is connected. The power output and all exported signals are disabled. This function performs the same actions as the niDCPower_reset function. 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int Disable(System.IntPtr Instrument_Handle)
        {
            int pInvokeResult = PInvoke.Disable(Instrument_Handle);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Resets the power supply to a reset state. The function disables power generation, resets session attributes to their default values, clears errors such as overtemperature and unexpected loss of auxiliary power, commits the session attributes, and leaves the session in Immediate mode.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int reset(System.IntPtr Instrument_Handle)
        {
            int pInvokeResult = PInvoke.reset(Instrument_Handle);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Resets the power supply to a reset state. The function disables power generation, resets session attributes to their default values, clears errors such as overtemperature and unexpected loss of auxiliary power, commits the session attributes, and leaves the session in Immediate mode. 
        /// 
        /// Performs a hard reset on the device and the driver software. This function has the same functionality as using reset in Measurement &amp; Automation Explorer.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int ResetDevice(System.IntPtr Instrument_Handle)
        {
            int pInvokeResult = PInvoke.ResetDevice(Instrument_Handle);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Performs the power supply self-test routine and returns the test result(s). Calling this function implicitly calls the niDCPower_reset function.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Self_Test_Result">
        /// Returns the value result from the power supply self-test. 0 indicates success. 
        /// </param>
        /// <param name="Self_Test_Message">
        /// Returns the self-test result message. The size of this array must be at least 256 bytes.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int self_test(System.IntPtr Instrument_Handle, out short Self_Test_Result, System.Text.StringBuilder Self_Test_Message)
        {
            int pInvokeResult = PInvoke.self_test(Instrument_Handle, out Self_Test_Result, Self_Test_Message);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the revision information of NI-DCPower and the power supply firmware.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Instrument_Driver_Revision">
        /// Returns the driver revision information for NI-DCPower.
        /// </param>
        /// <param name="Firmware_Revision">
        /// Returns firmware revision information for the power supply you are using. The size of this array must be at least 256 bytes.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int revision_query(System.IntPtr Instrument_Handle, System.Text.StringBuilder Instrument_Driver_Revision, System.Text.StringBuilder Firmware_Revision)
        {
            int pInvokeResult = PInvoke.revision_query(Instrument_Handle, Instrument_Driver_Revision, Firmware_Revision);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Resets the power supply to a reset state. This function disables power generation, resets session attributes to their default values, clears errors such as overtemperature and unexpected loss of auxiliary power, commits the session attributes, and leaves the session in Immediate mode. In addition to exhibiting the behavior of the niDCPower_reset function, this function can assign user-defined default values for configurable attributes from the IVI configuration.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int ResetWithDefaults(System.IntPtr Instrument_Handle)
        {
            int pInvokeResult = PInvoke.ResetWithDefaults(Instrument_Handle);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Retrieves the output Channel Name that corresponds to the requested Index. Use the NIDCPOWER_ATTR_CHANNEL_COUNT attribute to determine the upper bound of valid values for Index. 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Index">
        /// Specifies which output channel name to return. The index values begin at 1.
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// Specifies the number of bytes in the ViChar array you specify for Channel Name. If the Channel Name, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies (buffer size - 1) bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is 123456 and the buffer size is 4, the function places 123 into the buffer and returns 7.
        /// 
        /// If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// If you pass 0, you can pass VI_NULL for Channel Name.
        /// </param>
        /// <param name="Channel_Name">
        /// Returns the the output channel name that corresponds to Index.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int GetChannelName(System.IntPtr Instrument_Handle, int Index, int Buffer_Size, System.Text.StringBuilder Channel_Name)
        {
            int pInvokeResult = PInvoke.GetChannelName(Instrument_Handle, Index, Buffer_Size, Channel_Name);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the coercion information associated with the IVI session and clears the earliest instance in which NI-DCPower coerced a value you specified.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Buffer_Size">
        /// Specifies the number of bytes in the ViChar array you specify for Coercion Record. If the next Coercion Record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies (buffer size - 1) bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is 123456 and the buffer size is 4, the function places 123 into the buffer and returns 7.
        /// 
        /// If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// If you pass 0, you can pass VI_NULL for Coercion Record.
        /// </param>
        /// <param name="Coercion_Record">
        /// Returns the next Coercion Record for the IVI session. If there are no Coercion Records, the function returns an empty string.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int GetNextCoercionRecord(System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Coercion_Record)
        {
            int pInvokeResult = PInvoke.GetNextCoercionRecord(Instrument_Handle, Buffer_Size, Coercion_Record);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Clears the list of current interchange warnings.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int ClearInterchangeWarnings(System.IntPtr Instrument_Handle)
        {
            int pInvokeResult = PInvoke.ClearInterchangeWarnings(Instrument_Handle);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// When developing a complex test system that consists of multiple test modules, it is generally a good idea to design the test modules so that they can run in any order.  To do so requires ensuring that each test module completely configures the state of each instrument it uses.  If a particular test module does not completely configure the state of an instrument, the state of the instrument depends on the configuration from a previously executed test module.  If you execute the test modules in a different order, the behavior of the instrument and therefore the entire test module is likely to change.  This change in behavior is generally instrument specific and represents an interchangeability problem.
        /// 
        /// You can use this function to test for such cases.  After you call this function, the interchangeability checking algorithms in the specific driver ignore all previous configuration operations.  By calling this function at the beginning of a test module, you can determine whether the test module has dependencies on the operation of previously executed test modules.
        /// 
        /// This function does not clear the interchangeability warnings from the list of previously recorded interchangeability warnings.  If you want to guarantee that the niPower_GetNextInterchangeWarning function only returns those interchangeability warnings that are generated after calling this function, you must clear the list of interchangeability warnings.  You can clear the interchangeability warnings list by repeatedly calling the niPower_GetNextInterchangeWarning function until no more interchangeability warnings are returned.  If you are not interested in the content of those warnings, you can call the niPower_ClearInterchangeWarnings function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int ResetInterchangeCheck(System.IntPtr Instrument_Handle)
        {
            int pInvokeResult = PInvoke.ResetInterchangeCheck(Instrument_Handle);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function returns the interchangeability warning associated with the IVI session. It retrieves and clears the earliest instance in which the class driver recorded an interchangeability warning. Interchangeability warnings indicate that using your application with a different power supply may cause a different behavior. 
        /// 
        /// NI-DCPower performs interchangeability checking when Interchange Check is set to TRUE. This function returns an empty string in warning if no interchangeability warnings remain for the session. In general, NI-DCPower generates interchangeability warnings when an attribute that affects the behavior of the power supply is in a state that you did not specify.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Buffer_Size">
        /// Specifies the number of bytes in the ViChar array you specify for Coercion Record. If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies (buffer size - 1) bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the Buffer Size you must pass to get the entire value. For example, if the value is 123456 and the Buffer Size is 4, the function places 123 into the buffer and returns 7.
        /// 
        /// If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// If you pass 0, you can pass VI_NULL for Coercion Record.
        /// </param>
        /// <param name="Interchange_Warning">
        /// Returns the next Interchange Warning for the IVI session. If there are no Interchange Warnings, the function returns an empty string.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int GetNextInterchangeWarning(System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Interchange_Warning)
        {
            int pInvokeResult = PInvoke.GetNextInterchangeWarning(Instrument_Handle, Buffer_Size, Interchange_Warning);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function retrieves and then clears the IVI error information for the session or the current execution thread. One exception exists: If the BufferSize parameter is 0, the function does not clear the error information. By passing 0 for the buffer size, the caller can ascertain the buffer size required to get the entire error description string and then call the function again with a sufficiently large buffer.
        /// 
        /// If the user specifies a valid IVI session for the InstrumentHandle parameter, Get Error retrieves and then clears the error information for the session.  If the user passes VI_NULL for the InstrumentHandle parameter, this function retrieves and then clears the error information for the current execution thread.  If the InstrumentHandle parameter is an invalid session, the function does nothing and returns an error. Normally, the error information describes the first error that occurred since the user last called niPower_GetError or niPower_ClearError.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
        /// </param>
        /// <param name="Code">
        /// Returns the error code for the session or execution thread.
        /// 
        /// </param>
        /// <param name="BufferSize">
        /// Pass the number of bytes in the ViChar array you specify for the Description parameter.
        /// 
        /// If the error description, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies BufferSize - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the BufferSize is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// If you pass 0, you can pass VI_NULL for the Description parameter.
        /// 
        /// Default Value:  None
        /// </param>
        /// <param name="Description">
        /// Returns the error Description for the IVI session or execution thread.  If there is no Description, the function returns an empty string.
        /// 
        /// The buffer must contain at least as many elements as the value you specify with the BufferSize parameter.  If the error description, including the terminating NUL byte, contains more bytes than you indicate with the BufferSize parameter, the function copies BufferSize - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the BufferSize you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// If you pass 0 for the BufferSize, you can pass VI_NULL for this parameter.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int GetError(System.IntPtr Instrument_Handle, out int Code, int BufferSize, System.Text.StringBuilder Description)
        {
            int pInvokeResult = PInvoke.GetError(Instrument_Handle, out Code, BufferSize, Description);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function clears the error code and error description for the IVI session. If the user specifies a valid IVI session for the instrument_handle parameter, this function clears the error information for the session. If the user passes VI_NULL for the Vi parameter, this function clears the error information for the current execution thread. If the Vi parameter is an invalid session, the function does nothing and returns an error.
        /// The function clears the error code by setting it to VI_SUCCESS.  If the error description string is non-NULL, the function de-allocates the error description string and sets the address to VI_NULL.
        /// 
        /// Maintaining the error information separately for each thread is useful if the user does not have a session handle to pass to the niPower_GetError function, which occurs when a call to niPower_Init or niPower_InitWithOptions fails.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The ViSession handle that you obtain from niDCPower_Init or niDCPower_InitWithOptions. The handle identifies a particular device session. The default value is None.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int ClearError(System.IntPtr Instrument_Handle)
        {
            int pInvokeResult = PInvoke.ClearError(Instrument_Handle);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function converts a status code returned by an instrument driver function into a user-readable string. 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The ViSession handle that you obtain from the niPower_init or niPower_InitWithOptions function.  The handle identifies a particular instrument session.
        /// 
        /// You can pass VI_NULL for this parameter.  This is useful when one of the initialize functions fail.
        /// 
        /// Default Value:  VI_NULL
        /// 
        /// </param>
        /// <param name="Error_Code">
        /// Pass the Status parameter that is returned from any of the instrument driver functions.
        ///           
        /// Default Value:  0  (VI_SUCCESS)         
        /// </param>
        /// <param name="Error_Message_2">
        /// Returns the user-readable message string that corresponds to the status code you specify.
        /// 
        /// You must pass a ViChar array with at least 256 bytes.
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int error_message(System.IntPtr Instrument_Handle, int Error_Code, System.Text.StringBuilder Error_Message_2)
        {
            int pInvokeResult = PInvoke.error_message(Instrument_Handle, Error_Code, Error_Message_2);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function obtains a multithread lock on the instrument session.  Before it does so, it waits until all other execution threads have released their locks on the instrument session.
        /// 
        /// Other threads might have obtained a lock on this session in the following ways:
        /// 
        /// - The user's application called niPower_LockSession.
        /// 
        /// - A call to the instrument driver locked the session.
        /// 
        /// - A call to the IVI engine locked the session.
        /// 
        /// After your call to niPower_LockSession returns successfully, no other threads can access the instrument session until you call niPower_UnlockSession.
        /// 
        /// Use niPower_LockSession and niPower_UnlockSession around a sequence of calls to instrument driver functions if you require that the instrument retain its settings through the end of the sequence.
        /// 
        /// You can safely make nested calls to niPower_LockSession within the same thread.  To completely unlock the session, you must balance each call to niPower_LockSession with a call to niPower_UnlockSession.  If, however, you use the Caller Has Lock parameter in all calls to niPower_LockSession and niPower_UnlockSession within a function, the IVI Library locks the session only once within the function regardless of the number of calls you make to niPower_LockSession.  This allows you to call niPower_UnlockSession just once at the end of the function. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The ViSession handle that you obtain from the niPower_init or niPower_InitWithOptions function.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Caller_Has_Lock">
        /// This parameter serves as a convenience.  If you do not want to use this parameter, pass VI_NULL. 
        /// 
        /// Use this parameter in complex functions to keep track of whether you obtain a lock and therefore need to unlock the session.  Pass the address of a local ViBoolean variable.  In the declaration of the local variable, initialize it to VI_FALSE.  Pass the address of the same local variable to any other calls you make to niPower_LockSession or niPower_UnlockSession in the same function.
        /// 
        /// The parameter is an input/output parameter.  niPower_LockSession and niPower_UnlockSession each inspect the current value and take the following actions:
        /// 
        /// - If the value is VI_TRUE, niPower_LockSession does not lock the session again.  If the value is VI_FALSE, niPower_LockSession obtains the lock and sets the value of the parameter to VI_TRUE.
        /// 
        /// - If the value is VI_FALSE, niPower_UnlockSession does not attempt to unlock the session.  If the value is VI_TRUE, niPower_UnlockSession releases the lock and sets the value of the parameter to VI_FALSE.
        ///  
        /// Thus, you can, call niPower_UnlockSession at the end of your function without worrying about whether you actually have the lock.  
        /// 
        /// Example:
        /// 
        /// ViStatus TestFunc (ViSession vi, ViInt32 flags)
        /// {
        ///     ViStatus error = VI_SUCCESS;
        ///     ViBoolean haveLock = VI_FALSE;
        /// 
        ///     if (flags &amp; BIT_1)
        ///         {
        ///         viCheckErr( niPower_LockSession(vi, &amp;haveLock));
        ///         viCheckErr( TakeAction1(vi));
        ///         if (flags &amp; BIT_2)
        ///             {
        ///             viCheckErr( niPower_UnlockSession(vi, &amp;haveLock));
        ///             viCheckErr( TakeAction2(vi));
        ///             viCheckErr( niPower_LockSession(vi, &amp;haveLock);
        ///             } 
        ///         if (flags &amp; BIT_3)
        ///             viCheckErr( TakeAction3(vi));
        ///         }
        /// 
        /// Error:
        ///     /* 
        ///        At this point, you cannot really be sure that 
        ///        you have the lock.  Fortunately, the haveLock 
        ///        variable takes care of that for you.          
        ///     */
        ///     niPower_UnlockSession(vi, &amp;haveLock);
        ///     return error;
        /// }
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int LockSession(System.IntPtr Instrument_Handle, out bool Caller_Has_Lock)
        {
            System.UInt16 Caller_Has_LockAsUShort;
            int pInvokeResult = PInvoke.LockSession(Instrument_Handle, out Caller_Has_LockAsUShort);
            Caller_Has_Lock = System.Convert.ToBoolean(Caller_Has_LockAsUShort);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function releases a lock that you acquired on an instrument session using niPower_LockSession.  Refer to niPower_LockSession for additional information on session locks.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The ViSession handle that you obtain from the niPower_init or niPower_InitWithOptions function.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Caller_Has_Lock">
        /// This parameter serves as a convenience.  If you do not want to use this parameter, pass VI_NULL. 
        /// 
        /// Use this parameter in complex functions to keep track of whether you obtain a lock and therefore need to unlock the session. 
        /// Pass the address of a local ViBoolean variable.  In the declaration of the local variable, initialize it to VI_FALSE.  Pass the address of the same local variable to any other calls you make to niPower_LockSession or niPower_UnlockSession in the same function.
        /// 
        /// The parameter is an input/output parameter.  niPower_LockSession and niPower_UnlockSession each inspect the current value and take the following actions:
        /// 
        /// - If the value is VI_TRUE, niPower_LockSession does not lock the session again.  If the value is VI_FALSE, niPower_LockSession obtains the lock and sets the value of the parameter to VI_TRUE.
        /// 
        /// - If the value is VI_FALSE, niPower_UnlockSession does not attempt to unlock the session.  If the value is VI_TRUE, niPower_UnlockSession releases the lock and sets the value of the parameter to VI_FALSE.
        ///  
        /// Thus, you can, call niPower_UnlockSession at the end of your function without worrying about whether you actually have the lock.  
        /// 
        /// Example:
        /// 
        /// ViStatus TestFunc (ViSession vi, ViInt32 flags)
        /// {
        ///     ViStatus error = VI_SUCCESS;
        ///     ViBoolean haveLock = VI_FALSE;
        /// 
        ///     if (flags &amp; BIT_1)
        ///         {
        ///         viCheckErr( niPower_LockSession(vi, &amp;haveLock));
        ///         viCheckErr( TakeAction1(vi));
        ///         if (flags &amp; BIT_2)
        ///             {
        ///             viCheckErr( niPower_UnlockSession(vi, &amp;haveLock));
        ///             viCheckErr( TakeAction2(vi));
        ///             viCheckErr( niPower_LockSession(vi, &amp;haveLock);
        ///             } 
        ///         if (flags &amp; BIT_3)
        ///             viCheckErr( TakeAction3(vi));
        ///         }
        /// 
        /// Error:
        ///     /* 
        ///        At this point, you cannot really be sure that 
        ///        you have the lock.  Fortunately, the haveLock 
        ///        variable takes care of that for you.          
        ///     */
        ///     niPower_UnlockSession(vi, &amp;haveLock);
        ///     return error;
        /// }
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
        /// </returns>
        public static int UnlockSession(System.IntPtr Instrument_Handle, out bool Caller_Has_Lock)
        {
            System.UInt16 Caller_Has_LockAsUShort;
            int pInvokeResult = PInvoke.UnlockSession(Instrument_Handle, out Caller_Has_LockAsUShort);
            Caller_Has_Lock = System.Convert.ToBoolean(Caller_Has_LockAsUShort);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        private class PInvoke
        {
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_init",CallingConvention=CallingConvention.StdCall)]
            public static extern int init (string Resource_Name, System.UInt16 ID_Query, System.UInt16 Reset_Device, out System.IntPtr Instrument_Handle);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_close",CallingConvention=CallingConvention.StdCall)]
            public static extern int close (System.IntPtr Instrument_Handle);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_ConfigureVoltageLevel",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureVoltageLevel (System.IntPtr Instrument_Handle, string Channel_Name, System.Double Level);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_ConfigureCurrentLimit",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureCurrentLimit (System.IntPtr Instrument_Handle, string Channel_Name, int Behavior, System.Double Limit);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_ConfigureOutputEnabled",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureOutputEnabled (System.IntPtr Instrument_Handle, string Channel_Name, System.UInt16 Enabled);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_ConfigureOutputRange",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureOutputRange (System.IntPtr Instrument_Handle, string Channel_Name, int Range_Type, System.Double Range);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_Initiate",CallingConvention=CallingConvention.StdCall)]
            public static extern int Initiate (System.IntPtr Instrument_Handle);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_Abort",CallingConvention=CallingConvention.StdCall)]
            public static extern int Abort (System.IntPtr Instrument_Handle);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_SetAttributeViInt32",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViInt32 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, int Attribute_Value);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_SetAttributeViReal64",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViReal64 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.Double Attribute_Value);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_SetAttributeViString",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViString (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, string Attribute_Value);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_SetAttributeViBoolean",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViBoolean (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.UInt16 Attribute_Value);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_SetAttributeViSession",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViSession (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.IntPtr Attribute_Value);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_GetAttributeViInt32",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViInt32 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out int Attribute_Value);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_GetAttributeViReal64",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViReal64 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.Double Attribute_Value);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_GetAttributeViString",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViString (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, int Buffer_Size, System.Text.StringBuilder Attribute_Value);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_GetAttributeViBoolean",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViBoolean (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.UInt16 Attribute_Value);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_GetAttributeViSession",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViSession (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.IntPtr Attribute_Value);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_QueryOutputState",CallingConvention=CallingConvention.StdCall)]
            public static extern int QueryOutputState (System.IntPtr Instrument_Handle, string Channel_Name, int Output_State, out System.UInt16 In_State);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_Measure",CallingConvention=CallingConvention.StdCall)]
            public static extern int Measure (System.IntPtr Instrument_Handle, string Channel_Name, int Measurement_Type, out System.Double Measurement);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_MeasureMultiple",CallingConvention=CallingConvention.StdCall)]
            public static extern int MeasureMultiple (System.IntPtr Instrument_Handle, string Channel_Name, [In, Out] System.Double[] Voltage_Measurements, [In, Out] System.Double[] Current_Measurements);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_QueryMaxCurrentLimit",CallingConvention=CallingConvention.StdCall)]
            public static extern int QueryMaxCurrentLimit (System.IntPtr Instrument_Handle, string Channel_Name, System.Double Voltage_Level, out System.Double Max_Current_Limit);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_QueryMaxVoltageLevel",CallingConvention=CallingConvention.StdCall)]
            public static extern int QueryMaxVoltageLevel (System.IntPtr Instrument_Handle, string Channel_Name, System.Double Current_Limit, out System.Double Max_Voltage_Level);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_QueryMinCurrentLimit",CallingConvention=CallingConvention.StdCall)]
            public static extern int QueryMinCurrentLimit (System.IntPtr Instrument_Handle, string Channel_Name, System.Double Voltage_Level, out System.Double Min_Current_Limit);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_InitExtCal",CallingConvention=CallingConvention.StdCall)]
            public static extern int InitExtCal (string Resource_Name, string Password, out System.IntPtr Instrument_Handle);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_CloseExtCal",CallingConvention=CallingConvention.StdCall)]
            public static extern int CloseExtCal (System.IntPtr Instrument_Handle, int Action);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_CalAdjustVoltageLevel",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustVoltageLevel (System.IntPtr Instrument_Handle, string Channel_Name, System.Double Range, System.UInt32 Number_Of_Measurements, System.Double Requested_Outputs, System.Double Measured_Outputs);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_CalAdjustVoltageMeasurement",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustVoltageMeasurement (System.IntPtr Instrument_Handle, string Channel_Name, System.Double Range, System.UInt32 Number_Of_Measurements, System.Double Reported_Outputs, System.Double Measured_Outputs);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_CalAdjustCurrentLimit",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustCurrentLimit (System.IntPtr Instrument_Handle, string Channel_Name, System.Double Range, System.UInt32 Number_Of_Measurements, System.Double Requested_Outputs, System.Double Measured_Outputs);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_CalAdjustCurrentMeasurement",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustCurrentMeasurement (System.IntPtr Instrument_Handle, string Channel_Name, System.Double Range, System.UInt32 Number_Of_Measurements, System.Double Reported_Outputs, System.Double Measured_Outputs);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_ChangeExtCalPassword",CallingConvention=CallingConvention.StdCall)]
            public static extern int ChangeExtCalPassword (System.IntPtr Instrument_Handle, string Old_Password, string New_Password);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_GetExtCalRecommendedInterval",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetExtCalRecommendedInterval (System.IntPtr Instrument_Handle, int Months);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_GetExtCalLastDateAndTime",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetExtCalLastDateAndTime (System.IntPtr Instrument_Handle, int Year, int Month, int Day, int Hour, int Minute);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_GetCalUserDefinedInfoMaxSize",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetCalUserDefinedInfoMaxSize (System.IntPtr Instrument_Handle, int Info_Size);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_SetCalUserDefinedInfo",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetCalUserDefinedInfo (System.IntPtr Instrument_Handle, string Info);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_GetCalUserDefinedInfo",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetCalUserDefinedInfo (System.IntPtr Instrument_Handle, string Info);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_ReadCurrentTemperature",CallingConvention=CallingConvention.StdCall)]
            public static extern int ReadCurrentTemperature (System.IntPtr Instrument_Handle, System.Double Temperature);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_GetExtCalLastTemp",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetExtCalLastTemp (System.IntPtr Instrument_Handle, System.Double Temperature);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_InitWithOptions",CallingConvention=CallingConvention.StdCall)]
            public static extern int InitWithOptions (string Resource_Name, System.UInt16 ID_Query, System.UInt16 Reset_Device, string Option_String, out System.IntPtr Instrument_Handle);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_Disable",CallingConvention=CallingConvention.StdCall)]
            public static extern int Disable (System.IntPtr Instrument_Handle);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_reset",CallingConvention=CallingConvention.StdCall)]
            public static extern int reset (System.IntPtr Instrument_Handle);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_ResetDevice",CallingConvention=CallingConvention.StdCall)]
            public static extern int ResetDevice (System.IntPtr Instrument_Handle);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_self_test",CallingConvention=CallingConvention.StdCall)]
            public static extern int self_test (System.IntPtr Instrument_Handle, out short Self_Test_Result, System.Text.StringBuilder Self_Test_Message);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_revision_query",CallingConvention=CallingConvention.StdCall)]
            public static extern int revision_query (System.IntPtr Instrument_Handle, System.Text.StringBuilder Instrument_Driver_Revision, System.Text.StringBuilder Firmware_Revision);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_ResetWithDefaults",CallingConvention=CallingConvention.StdCall)]
            public static extern int ResetWithDefaults (System.IntPtr Instrument_Handle);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_GetChannelName",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetChannelName (System.IntPtr Instrument_Handle, int Index, int Buffer_Size, System.Text.StringBuilder Channel_Name);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_GetNextCoercionRecord",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetNextCoercionRecord (System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Coercion_Record);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_ClearInterchangeWarnings",CallingConvention=CallingConvention.StdCall)]
            public static extern int ClearInterchangeWarnings (System.IntPtr Instrument_Handle);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_ResetInterchangeCheck",CallingConvention=CallingConvention.StdCall)]
            public static extern int ResetInterchangeCheck (System.IntPtr Instrument_Handle);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_GetNextInterchangeWarning",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetNextInterchangeWarning (System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Interchange_Warning);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_GetError",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetError (System.IntPtr Instrument_Handle, out int Code, int BufferSize, System.Text.StringBuilder Description);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_ClearError",CallingConvention=CallingConvention.StdCall)]
            public static extern int ClearError (System.IntPtr Instrument_Handle);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_error_message",CallingConvention=CallingConvention.StdCall)]
            public static extern int error_message (System.IntPtr Instrument_Handle, int Error_Code, System.Text.StringBuilder Error_Message_2);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_LockSession",CallingConvention=CallingConvention.StdCall)]
            public static extern int LockSession (System.IntPtr Instrument_Handle, out System.UInt16 Caller_Has_Lock);
            
            [DllImport("niDCPower_32.dll",EntryPoint="niDCPower_UnlockSession",CallingConvention=CallingConvention.StdCall)]
            public static extern int UnlockSession (System.IntPtr Instrument_Handle, out System.UInt16 Caller_Has_Lock);
            
            public static int TestForError(System.IntPtr handle, int status)
            {
                if ((status < 0))
                {
                    PInvoke.ThrowError(handle, status);
                }
                return status;
            }
            
            public static int ThrowError(System.IntPtr handle, int code)
            {
                throw new System.Runtime.InteropServices.ExternalException("", code);
            }
        }
    }
    
    public class niDCPowerConstants
    {
        
        public const int RangeCurrent = 0;
        
        public const int MeasureCurrent = 0;
        
        public const int OutputConstantVoltage = 0;
        
        public const int Internal = 1003;
        
        public const int OutputConstantCurrent = 1;
        
        public const int Cancel = 1001;
        
        public const int Commit = 1002;
        
        public const int RangeVoltage = 1;
        
        public const int Auxiliary = 1004;
        
        public const int CurrentRegulate = 0;
        
        public const int Automatic = 1005;
        
        public const int MeasureVoltage = 1;
    }
}
